Imports PCComm
Public Class frmMain
    Private comm As New CommManager()
    Private transType As String = String.Empty

    Private Sub cboPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboPort.SelectedIndexChanged
        comm.PortName = cboPort.Text()
    End Sub

    ''' <summary>
    ''' Method to initialize serial port
    ''' values to standard defaults
    ''' </summary>
    Private Sub SetDefaults()
        cboPort.SelectedIndex = 0
        cboBaud.SelectedText = "9600"
        cboParity.SelectedIndex = 0
        cboStop.SelectedIndex = 1
        cboData.SelectedIndex = 1
    End Sub

    ''' <summary>
    ''' methos to load our serial
    ''' port option values
    ''' </summary>
    Private Sub LoadValues()
        Dim selIndex As Integer = cboPort.SelectedIndex
        cboPort.Items.Clear()
        comm.SetPortNameValues(cboPort)
        Try
            cboPort.SelectedIndex = selIndex
        Catch ex As Exception

        End Try
        selIndex = cboParity.SelectedIndex
        cboParity.Items.Clear()
        comm.SetParityValues(cboParity)
        Try
            cboParity.SelectedIndex = selIndex
        Catch ex As Exception

        End Try
        selIndex = cboStop.SelectedIndex
        cboStop.Items.Clear()

        comm.SetStopBitValues(cboStop)
        Try
            cboStop.SelectedIndex = selIndex
        Catch ex As Exception

        End Try
    End Sub

    ''' <summary>
    ''' method to set the state of controls
    ''' when the form first loads
    ''' </summary>
    Private Sub SetControlState()
        rdoText.Checked = True
        cmdSend.Enabled = False
        cmdClose.Enabled = False
    End Sub

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadValues()
        SetDefaults()
        SetControlState()
    End Sub

    Private Sub cmdClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdClose.Click
        comm.ClosePort()
        SetControlState()
        'SetDefaults()
        cmdOpen.Enabled = True
        cmdClose.Enabled = False
        cmdSend.Enabled = False
    End Sub

    Private Sub cmdOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdOpen.Click
        comm.Parity = cboParity.Text
        comm.StopBits = cboStop.Text
        comm.DataBits = cboData.Text
        comm.BaudRate = cboBaud.Text
        comm.DisplayWindow = rtbDisplay
        comm.OpenPort()

        cmdOpen.Enabled = False
        cmdClose.Enabled = True
        cmdSend.Enabled = True
    End Sub

    Private Sub cmdSend_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSend.Click
        comm.Message = txtSend.Text
        comm.Type = CommManager.MessageType.Normal
        If rdoText.Checked Then
            comm.WriteData(txtSend.Text & vbCrLf)
        Else
            comm.WriteData(txtSend.Text)
        End If

        txtSend.Text = String.Empty
        txtSend.Focus()
    End Sub

    Private Sub rdoHex_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoHex.CheckedChanged
        If rdoHex.Checked() Then
            comm.CurrentTransmissionType = PCComm.CommManager.TransmissionType.Hex
        Else
            comm.CurrentTransmissionType = PCComm.CommManager.TransmissionType.Text
        End If
    End Sub

    Private Sub cboBaud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboBaud.SelectedIndexChanged
        comm.BaudRate = cboBaud.Text()
    End Sub

    Private Sub cboParity_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboParity.SelectedIndexChanged
        comm.Parity = cboParity.Text()
    End Sub

    Private Sub cboStop_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboStop.SelectedIndexChanged
        comm.StopBits = cboStop.Text()
    End Sub

    Private Sub cboData_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboData.SelectedIndexChanged
        comm.StopBits = cboStop.Text()
    End Sub

    Private Sub txtSend_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtSend.KeyUp
        If e.KeyCode = Keys.Enter Then

            'send message 
            If cmdOpen.Enabled = True Then
                MsgBox("Connect before to send a message")
                Return
            End If


            cmdSend_Click(sender, e)


        End If

    End Sub

    Private Sub txtSend_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtSend.TextChanged

    End Sub

    Private Sub rtbDisplay_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rtbDisplay.TextChanged

    End Sub

    Private Sub rdoText_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoText.CheckedChanged

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        comm.CurrentTransmissionType = PCComm.CommManager.TransmissionType.Hex
        comm.Message = "0D0A55BB55BBFF000000FF0D0A"
        comm.Type = CommManager.MessageType.Normal
        comm.WriteData("0D0A55BB55BBFF000000FF0D0A")
        If rdoHex.Checked() Then
            comm.CurrentTransmissionType = PCComm.CommManager.TransmissionType.Hex
        Else
            comm.CurrentTransmissionType = PCComm.CommManager.TransmissionType.Text
        End If
    End Sub

    Private Sub GroupBox1_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GroupBox1.Enter

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        LoadValues()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        comm.CurrentTransmissionType = PCComm.CommManager.TransmissionType.Hex
        comm.Message = "55BB55BBFE000000FE0D0A"
        comm.Type = CommManager.MessageType.Normal
        comm.WriteData("55BB55BBFE000000FE0D0A")
        If rdoHex.Checked() Then
            comm.CurrentTransmissionType = PCComm.CommManager.TransmissionType.Hex
        Else
            comm.CurrentTransmissionType = PCComm.CommManager.TransmissionType.Text
        End If
    End Sub
End Class